#version 330 // GLSL verzia

uniform mat4 modelview_mat;  // modelview matica
uniform mat4 projection_mat; // projection matica

// VERTEX atributy
layout (location = 0) in vec3 in_pos; // poloha vrcholu v OBJECT space
layout (location = 1) in vec3 in_col; // farba
layout (location = 4) in vec3 in_nor; // normala
layout (location = 8) in vec2 in_uv;  // texturovacie suradnice

out vec3 col;
out vec3 nor;
out vec2 uv;

vec4 pos;

void main()
{
 // poloha vrcholu v EYE space
 pos=modelview_mat*vec4(in_pos,1.0);

 // poloha vrcholu v CLIP space
 gl_Position=projection_mat*pos;

 // farba
 col=in_col;

 // normala
 //nor=(gl_NormalMatrix*in_nor);
 // ak sa pouziva rovnomerne skalovanie,
 // potom gl_NormalMatrix=gl_ModelViewMatrix
 nor=vec3(modelview_mat*vec4(in_nor,0.0));

 // texturovacie suradnice
 uv=in_uv;
}